/*************************************************************************************************
   Demo / rzrDemo.h

   - Demo system

*************************************************************************************************/
#pragma once

#include "directx/include/d3d9.h"
#include "minifmod/minifmod.h"

#include "rzrTypes.h"

/*************************************************************************************************
 *
 * Vertex structures
 */
struct rzVertex
{
    struct rzPosition
    {
        rzFloat x, y, z, w;
    } pos;
    struct rzUV
    {
        rzFloat u, v;
    } coord[3];
    rzFloat fade;
};

/*************************************************************************************************
 *
 * The Demo
 */
class rzrDemo
{
public:
    rzrDemo();
    ~rzrDemo();

    rzErrCode Init(HWND hWnd);

    rzBool Process();

private:
    rzBool m_bFirstFrame;
    HWND m_hWnd;

    rzQword m_qPerfFrequency;
    rzQword m_qPerfCounter;
    rzFloat m_fTime;

    IDirect3D9 *m_pD3D;

    IDirect3DDevice9 *m_pD3DDevice;
    rzLong m_dWidth, m_dHeight;

    IDirect3DSurface9 *m_pD3DScreen;
    HBITMAP m_hBitmap;
    void* m_pBitmap;

    IDirect3DVertexDeclaration9 *m_pD3DVD;
    IDirect3DPixelShader9 *m_pD3DPS;

    IDirect3DTexture9 *m_pD3DTextureLogo;
    rzLong m_dTextureLogoWidth, m_dTextureLogoHeight;
    rzLong m_dLogoWidth, m_dLogoHeight;

    FMUSIC_MODULE *m_pMod;

    void Effect();
};
