#include "stdafx.h"

static rzrDemo* g_pDemo = NULL;

/*************************************************************************************************
 *
 * Message procedure
 */
static LRESULT WINAPI MsgProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    switch(msg)
    {
        case WM_DESTROY:
            delete g_pDemo; g_pDemo = rzNULL;
            PostQuitMessage(0);
            return 0;
#if _DEBUG
        case WM_KEYDOWN:
            if (wParam==VK_ESCAPE)
                DestroyWindow(hWnd);
            break;
#endif
    }

    return DefWindowProc(hWnd, msg, wParam, lParam);
}

/*************************************************************************************************
 *
 * 
 */
void RazorDemo()
{
    // Register the window class
    WNDCLASSEX wc =
    {
        sizeof(WNDCLASSEX), CS_CLASSDC, MsgProc, 0L, 0L,
        GetModuleHandle(NULL), NULL, NULL, NULL, NULL,
        L"Razor1911", NULL
    };
    RegisterClassEx(&wc);

    RECT rc;
    GetClientRect(GetDesktopWindow(), &rc);

    // Create the application's window
    HWND hWnd = CreateWindow(L"Razor1911", L"Razor 1911",
                             WS_POPUP, (rc.right - rc.left - 800)>>1, (rc.bottom - rc.top - 300)>>1, 800, 300,
                             NULL, NULL, wc.hInstance, NULL);

    g_pDemo = new rzrDemo;
    if (!g_pDemo->Init(hWnd))
    {
        // Show the window
//         ShowWindow(hWnd, SW_SHOWDEFAULT);
//         UpdateWindow(hWnd);

        // Enter the message loop
        MSG msg;
        ZeroMemory(&msg, sizeof(msg));
        while (msg.message!=WM_QUIT)
        {
            if (PeekMessage(&msg, NULL, 0U, 0U, PM_REMOVE))
            {
                TranslateMessage(&msg);
                DispatchMessage(&msg);
            }
            else
            {
                if (g_pDemo->Process())
                    DestroyWindow(hWnd);
            }
        }
    }

    delete g_pDemo;

    UnregisterClass(L"Razor1911", wc.hInstance);
}
